"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var mappingBase_1 = require("./mappingBase");
var mappingModel_1 = require("./mappingModel");
var DateMapping = (function (_super) {
    __extends(DateMapping, _super);
    function DateMapping() {
        return _super.call(this, 8) || this;
    }
    DateMapping.prototype.read = function (context, value) {
        if (value == null)
            return null;
        if (!(value instanceof Date)) {
            context.addError("Expected Date.");
            return;
        }
        return new Date(value.getTime());
    };
    DateMapping.prototype.write = function (context, value) {
        if (value == null)
            return null;
        if (!(value instanceof Date)) {
            context.addError("Expected Date.");
            return;
        }
        return new Date(value.getTime());
    };
    DateMapping.prototype.areEqual = function (documentValue1, documentValue2) {
        if (documentValue1 instanceof Date && documentValue2 instanceof Date) {
            return documentValue1.getTime() == documentValue2.getTime();
        }
        return false;
    };
    return DateMapping;
}(mappingBase_1.MappingBase));
exports.DateMapping = DateMapping;
